## Ms Basic Connect Extensions service Ms Basic Connect Extensions service — Support for the Ms Basic Connect Extensions service. |

## Functions

void | mbim_pco_value_free ()
void | mbim_lte_attach_configuration_array_free ()
void | mbim_slot_array_free ()
MbimMessage * | mbim_message_ms_basic_connect_extensions_pco_query_new ()
gboolean | mbim_message_ms_basic_connect_extensions_pco_response_parse ()
gboolean | mbim_message_ms_basic_connect_extensions_pco_notification_parse ()
MbimMessage * | mbim_message_ms_basic_connect_extensions_lte_attach_configuration_query_new ()
MbimMessage * | mbim_message_ms_basic_connect_extensions_lte_attach_configuration_set_new ()
gboolean | mbim_message_ms_basic_connect_extensions_lte_attach_configuration_response_parse ()
gboolean | mbim_message_ms_basic_connect_extensions_lte_attach_configuration_notification_parse ()
MbimMessage * | mbim_message_ms_basic_connect_extensions_lte_attach_info_query_new ()
gboolean | mbim_message_ms_basic_connect_extensions_lte_attach_info_response_parse ()
gboolean | mbim_message_ms_basic_connect_extensions_lte_attach_info_notification_parse ()
MbimMessage * | mbim_message_ms_basic_connect_extensions_sys_caps_query_new ()
gboolean | mbim_message_ms_basic_connect_extensions_sys_caps_response_parse ()
MbimMessage * | mbim_message_ms_basic_connect_extensions_slot_info_status_query_new ()
gboolean | mbim_message_ms_basic_connect_extensions_slot_info_status_response_parse ()
gboolean | mbim_message_ms_basic_connect_extensions_slot_info_status_notification_parse ()
MbimMessage * | mbim_message_ms_basic_connect_extensions_device_slot_mappings_query_new ()
MbimMessage * | mbim_message_ms_basic_connect_extensions_device_slot_mappings_set_new ()
gboolean | mbim_message_ms_basic_connect_extensions_device_slot_mappings_response_parse ()
MbimMessage * | mbim_message_ms_basic_connect_extensions_device_caps_query_new ()
gboolean | mbim_message_ms_basic_connect_extensions_device_caps_response_parse ()

## Types and Values

| MbimPcoValue
| MbimLteAttachConfiguration
typedef | MbimLteAttachConfigurationArray
| MbimSlot
typedef | MbimSlotArray

## Description

This section implements support for requests, responses and notifications in the Ms Basic Connect Extensions service.

## Functions

### mbim_pco_value_free ()

    void
    mbim_pco_value_free (MbimPcoValue *var);

Frees the memory allocated for the MbimPcoValue.

#### Parameters

var | a MbimPcoValue. |

Since: 1.18

### mbim_lte_attach_configuration_array_free ()

    void
    mbim_lte_attach_configuration_array_free
                                   (MbimLteAttachConfigurationArray *array);

Frees the memory allocated for the array of MbimLteAttachConfiguration structs.

#### Parameters

array | a NULL terminated array of MbimLteAttachConfiguration structs. |

Since: 1.18

### mbim_slot_array_free ()

    void
    mbim_slot_array_free (MbimSlotArray *array);

Frees the memory allocated for the array of MbimSlot structs.

#### Parameters

array | a NULL terminated array of MbimSlot structs. |

Since: 1.26

### mbim_message_ms_basic_connect_extensions_pco_query_new ()

    MbimMessage *
    mbim_message_ms_basic_connect_extensions_pco_query_new
                                   (const MbimPcoValue *pco_value,
                                    GError **error);

Create a new request for the 'PCO' query command in the 'Ms Basic Connect Extensions' service.

#### Parameters

pco_value | the 'PcoValue' field, given as a MbimPcoValue. | [in]
error | return location for error or `NULL`. |

#### Returns

a newly allocated MbimMessage, which should be freed with `mbim_message_unref()`.

Since: 1.18

### mbim_message_ms_basic_connect_extensions_pco_response_parse ()

    gboolean
    mbim_message_ms_basic_connect_extensions_pco_response_parse
                                   (const MbimMessage *message,
                                    MbimPcoValue **out_pco_value,
                                    GError **error);

Parses and returns parameters of the 'PCO' response command in the 'Ms Basic Connect Extensions' service.

#### Parameters

message | the MbimMessage. |
out_pco_value | return location for a newly allocated MbimPcoValue, or `NULL` if the 'PcoValue' field is not needed. Free the returned value with `mbim_pco_value_free()`. | [out][optional][transfer full]
error | return location for error or `NULL`. |

#### Returns

`TRUE` if the message was correctly parsed, `FALSE` if `error` is set.

Since: 1.18

### mbim_message_ms_basic_connect_extensions_pco_notification_parse ()

    gboolean
    mbim_message_ms_basic_connect_extensions_pco_notification_parse
                                   (const MbimMessage *message,
                                    MbimPcoValue **out_pco_value,
                                    GError **error);

Parses and returns parameters of the 'PCO' notification command in the 'Ms Basic Connect Extensions' service.

#### Parameters

message | the MbimMessage. |
out_pco_value | return location for a newly allocated MbimPcoValue, or `NULL` if the 'PcoValue' field is not needed. Free the returned value with `mbim_pco_value_free()`. | [out][optional][transfer full]
error | return location for error or `NULL`. |

#### Returns

`TRUE` if the message was correctly parsed, `FALSE` if `error` is set.

Since: 1.18

### mbim_message_ms_basic_connect_extensions_lte_attach_configuration_query_new ()

    MbimMessage *
    mbim_message_ms_basic_connect_extensions_lte_attach_configuration_query_new
                                   (GError **error);

Create a new request for the 'Lte Attach Configuration' query command in the 'Ms Basic Connect Extensions' service.

#### Parameters

error | return location for error or `NULL`. |

#### Returns

a newly allocated MbimMessage, which should be freed with `mbim_message_unref()`.

Since: 1.18

### mbim_message_ms_basic_connect_extensions_lte_attach_configuration_set_new ()

    MbimMessage *
    mbim_message_ms_basic_connect_extensions_lte_attach_configuration_set_new
                                   (MbimLteAttachContextOperation operation,
                                    guint32 configuration_count,
                                    const MbimLteAttachConfiguration *const *configurations,
                                    GError **error);

Create a new request for the 'Lte Attach Configuration' set command in the 'Ms Basic Connect Extensions' service.

#### Parameters

operation | the 'Operation' field, given as a MbimLteAttachContextOperation. | [in]
configuration_count | the 'ConfigurationCount' field, given as a guint32. | [in]
configurations | the 'Configurations' field, given as an array of MbimLteAttachConfiguration items. | [in]
error | return location for error or `NULL`. |

#### Returns

a newly allocated MbimMessage, which should be freed with `mbim_message_unref()`.

Since: 1.18

### mbim_message_ms_basic_connect_extensions_lte_attach_configuration_response_parse ()

    gboolean
    mbim_message_ms_basic_connect_extensions_lte_attach_configuration_response_parse
                                   (const MbimMessage *message,
                                    guint32 *out_configuration_count,
                                    MbimLteAttachConfigurationArray **out_configurations,
                                    GError **error);

Parses and returns parameters of the 'Lte Attach Configuration' response command in the 'Ms Basic Connect Extensions' service.

#### Parameters

message | the MbimMessage. |
out_configuration_count | return location for a guint32, or `NULL` if the 'ConfigurationCount' field is not needed. | [out][optional][transfer none]
out_configurations | return location for a newly allocated array of MbimLteAttachConfiguration items, or `NULL` if the 'Configurations' field is not needed. Free the returned value with `mbim_lte_attach_configuration_array_free()`. | [out][optional][transfer full][array zero-terminated=1][element-type MbimLteAttachConfiguration]
error | return location for error or `NULL`. |

#### Returns

`TRUE` if the message was correctly parsed, `FALSE` if `error` is set.

Since: 1.18

### mbim_message_ms_basic_connect_extensions_lte_attach_configuration_notification_parse ()

    gboolean
    mbim_message_ms_basic_connect_extensions_lte_attach_configuration_notification_parse
                                   (const MbimMessage *message,
                                    guint32 *out_configuration_count,
                                    MbimLteAttachConfigurationArray **out_configurations,
                                    GError **error);

Parses and returns parameters of the 'Lte Attach Configuration' notification command in the 'Ms Basic Connect Extensions' service.

#### Parameters

message | the MbimMessage. |
out_configuration_count | return location for a guint32, or `NULL` if the 'ConfigurationCount' field is not needed. | [out][optional][transfer none]
out_configurations | return location for a newly allocated array of MbimLteAttachConfiguration items, or `NULL` if the 'Configurations' field is not needed. Free the returned value with `mbim_lte_attach_configuration_array_free()`. | [out][optional][transfer full][array zero-terminated=1][element-type MbimLteAttachConfiguration]
error | return location for error or `NULL`. |

#### Returns

`TRUE` if the message was correctly parsed, `FALSE` if `error` is set.

Since: 1.18

### mbim_message_ms_basic_connect_extensions_lte_attach_info_query_new ()

    MbimMessage *
    mbim_message_ms_basic_connect_extensions_lte_attach_info_query_new
                                   (GError **error);

Create a new request for the 'Lte Attach Info' query command in the 'Ms Basic Connect Extensions' service.

#### Parameters

error | return location for error or `NULL`. |

#### Returns

a newly allocated MbimMessage, which should be freed with `mbim_message_unref()`.

Since: 1.26

### mbim_message_ms_basic_connect_extensions_lte_attach_info_response_parse ()

    gboolean
    mbim_message_ms_basic_connect_extensions_lte_attach_info_response_parse
                                   (const MbimMessage *message,
                                    MbimLteAttachState *out_lte_attach_state,
                                    MbimContextIpType *out_ip_type,
                                    gchar **out_access_string,
                                    gchar **out_user_name,
                                    gchar **out_password,
                                    MbimCompression *out_compression,
                                    MbimAuthProtocol *out_auth_protocol,
                                    GError **error);

Parses and returns parameters of the 'Lte Attach Info' response command in the 'Ms Basic Connect Extensions' service.

#### Parameters

message | the MbimMessage. |
out_lte_attach_state | return location for a MbimLteAttachState, or `NULL` if the 'LteAttachState' field is not needed. | [out][optional][transfer none]
out_ip_type | return location for a MbimContextIpType, or `NULL` if the 'IpType' field is not needed. | [out][optional][transfer none]
out_access_string | return location for a newly allocated string, or `NULL` if the 'AccessString' field is not needed. Free the returned value with `g_free()`. | [out][optional][transfer full]
out_user_name | return location for a newly allocated string, or `NULL` if the 'UserName' field is not needed. Free the returned value with `g_free()`. | [out][optional][transfer full]
out_password | return location for a newly allocated string, or `NULL` if the 'Password' field is not needed. Free the returned value with `g_free()`. | [out][optional][transfer full]
out_compression | return location for a MbimCompression, or `NULL` if the 'Compression' field is not needed. | [out][optional][transfer none]
out_auth_protocol | return location for a MbimAuthProtocol, or `NULL` if the 'AuthProtocol' field is not needed. | [out][optional][transfer none]
error | return location for error or `NULL`. |

#### Returns

`TRUE` if the message was correctly parsed, `FALSE` if `error` is set.

Since: 1.26

### mbim_message_ms_basic_connect_extensions_lte_attach_info_notification_parse ()

    gboolean
    mbim_message_ms_basic_connect_extensions_lte_attach_info_notification_parse
                                   (const MbimMessage *message,
                                    MbimLteAttachState *out_lte_attach_state,
                                    MbimContextIpType *out_ip_type,
                                    gchar **out_access_string,
                                    gchar **out_user_name,
                                    gchar **out_password,
                                    MbimCompression *out_compression,
                                    MbimAuthProtocol *out_auth_protocol,
                                    GError **error);

Parses and returns parameters of the 'Lte Attach Info' notification command in the 'Ms Basic Connect Extensions' service.

#### Parameters

message | the MbimMessage. |
out_lte_attach_state | return location for a MbimLteAttachState, or `NULL` if the 'LteAttachState' field is not needed. | [out][optional][transfer none]
out_ip_type | return location for a MbimContextIpType, or `NULL` if the 'IpType' field is not needed. | [out][optional][transfer none]
out_access_string | return location for a newly allocated string, or `NULL` if the 'AccessString' field is not needed. Free the returned value with `g_free()`. | [out][optional][transfer full]
out_user_name | return location for a newly allocated string, or `NULL` if the 'UserName' field is not needed. Free the returned value with `g_free()`. | [out][optional][transfer full]
out_password | return location for a newly allocated string, or `NULL` if the 'Password' field is not needed. Free the returned value with `g_free()`. | [out][optional][transfer full]
out_compression | return location for a MbimCompression, or `NULL` if the 'Compression' field is not needed. | [out][optional][transfer none]
out_auth_protocol | return location for a MbimAuthProtocol, or `NULL` if the 'AuthProtocol' field is not needed. | [out][optional][transfer none]
error | return location for error or `NULL`. |

#### Returns

`TRUE` if the message was correctly parsed, `FALSE` if `error` is set.

Since: 1.26

### mbim_message_ms_basic_connect_extensions_sys_caps_query_new ()

    MbimMessage *
    mbim_message_ms_basic_connect_extensions_sys_caps_query_new
                                   (GError **error);

Create a new request for the 'Sys Caps' query command in the 'Ms Basic Connect Extensions' service.

#### Parameters

error | return location for error or `NULL`. |

#### Returns

a newly allocated MbimMessage, which should be freed with `mbim_message_unref()`.

Since: 1.26

### mbim_message_ms_basic_connect_extensions_sys_caps_response_parse ()

    gboolean
    mbim_message_ms_basic_connect_extensions_sys_caps_response_parse
                                   (const MbimMessage *message,
                                    guint32 *out_number_of_executors,
                                    guint32 *out_number_of_slots,
                                    guint32 *out_concurrency,
                                    guint64 *out_modem_id,
                                    GError **error);

Parses and returns parameters of the 'Sys Caps' response command in the 'Ms Basic Connect Extensions' service.

#### Parameters

message | the MbimMessage. |
out_number_of_executors | return location for a guint32, or `NULL` if the 'NumberOfExecutors' field is not needed. | [out][optional][transfer none]
out_number_of_slots | return location for a guint32, or `NULL` if the 'NumberOfSlots' field is not needed. | [out][optional][transfer none]
out_concurrency | return location for a guint32, or `NULL` if the 'Concurrency' field is not needed. | [out][optional][transfer none]
out_modem_id | return location for a guint64, or `NULL` if the 'ModemId' field is not needed. | [out][optional][transfer none]
error | return location for error or `NULL`. |

#### Returns

`TRUE` if the message was correctly parsed, `FALSE` if `error` is set.

Since: 1.26

### mbim_message_ms_basic_connect_extensions_slot_info_status_query_new ()

    MbimMessage *
    mbim_message_ms_basic_connect_extensions_slot_info_status_query_new
                                   (guint32 slot_index,
                                    GError **error);

Create a new request for the 'Slot Info Status' query command in the 'Ms Basic Connect Extensions' service.

#### Parameters

slot_index | the 'SlotIndex' field, given as a guint32. | [in]
error | return location for error or `NULL`. |

#### Returns

a newly allocated MbimMessage, which should be freed with `mbim_message_unref()`.

Since: 1.26

### mbim_message_ms_basic_connect_extensions_slot_info_status_response_parse ()

    gboolean
    mbim_message_ms_basic_connect_extensions_slot_info_status_response_parse
                                   (const MbimMessage *message,
                                    guint32 *out_slot_index,
                                    MbimUiccSlotState *out_state,
                                    GError **error);

Parses and returns parameters of the 'Slot Info Status' response command in the 'Ms Basic Connect Extensions' service.

#### Parameters

message | the MbimMessage. |
out_slot_index | return location for a guint32, or `NULL` if the 'SlotIndex' field is not needed. | [out][optional][transfer none]
out_state | return location for a MbimUiccSlotState, or `NULL` if the 'State' field is not needed. | [out][optional][transfer none]
error | return location for error or `NULL`. |

#### Returns

`TRUE` if the message was correctly parsed, `FALSE` if `error` is set.

Since: 1.26

### mbim_message_ms_basic_connect_extensions_slot_info_status_notification_parse ()

    gboolean
    mbim_message_ms_basic_connect_extensions_slot_info_status_notification_parse
                                   (const MbimMessage *message,
                                    guint32 *out_slot_index,
                                    MbimUiccSlotState *out_state,
                                    GError **error);

Parses and returns parameters of the 'Slot Info Status' notification command in the 'Ms Basic Connect Extensions' service.

#### Parameters

message | the MbimMessage. |
out_slot_index | return location for a guint32, or `NULL` if the 'SlotIndex' field is not needed. | [out][optional][transfer none]
out_state | return location for a MbimUiccSlotState, or `NULL` if the 'State' field is not needed. | [out][optional][transfer none]
error | return location for error or `NULL`. |

#### Returns

`TRUE` if the message was correctly parsed, `FALSE` if `error` is set.

Since: 1.26

### mbim_message_ms_basic_connect_extensions_device_slot_mappings_query_new ()

    MbimMessage *
    mbim_message_ms_basic_connect_extensions_device_slot_mappings_query_new
                                   (GError **error);

Create a new request for the 'Device Slot Mappings' query command in the 'Ms Basic Connect Extensions' service.

#### Parameters

error | return location for error or `NULL`. |

#### Returns

a newly allocated MbimMessage, which should be freed with `mbim_message_unref()`.

Since: 1.26

### mbim_message_ms_basic_connect_extensions_device_slot_mappings_set_new ()

    MbimMessage *
    mbim_message_ms_basic_connect_extensions_device_slot_mappings_set_new
                                   (guint32 map_count,
                                    const MbimSlot *const *slot_map,
                                    GError **error);

Create a new request for the 'Device Slot Mappings' set command in the 'Ms Basic Connect Extensions' service.

#### Parameters

map_count | the 'MapCount' field, given as a guint32. | [in]
slot_map | the 'SlotMap' field, given as an array of MbimSlot items. | [in]
error | return location for error or `NULL`. |

#### Returns

a newly allocated MbimMessage, which should be freed with `mbim_message_unref()`.

Since: 1.26

### mbim_message_ms_basic_connect_extensions_device_slot_mappings_response_parse ()

    gboolean
    mbim_message_ms_basic_connect_extensions_device_slot_mappings_response_parse
                                   (const MbimMessage *message,
                                    guint32 *out_map_count,
                                    MbimSlotArray **out_slot_map,
                                    GError **error);

Parses and returns parameters of the 'Device Slot Mappings' response command in the 'Ms Basic Connect Extensions' service.

#### Parameters

message | the MbimMessage. |
out_map_count | return location for a guint32, or `NULL` if the 'MapCount' field is not needed. | [out][optional][transfer none]
out_slot_map | return location for a newly allocated array of MbimSlot items, or `NULL` if the 'SlotMap' field is not needed. Free the returned value with `mbim_slot_array_free()`. | [out][optional][transfer full][array zero-terminated=1][element-type MbimSlot]
error | return location for error or `NULL`. |

#### Returns

`TRUE` if the message was correctly parsed, `FALSE` if `error` is set.

Since: 1.26

### mbim_message_ms_basic_connect_extensions_device_caps_query_new ()

    MbimMessage *
    mbim_message_ms_basic_connect_extensions_device_caps_query_new
                                   (GError **error);

Create a new request for the 'Device Caps' query command in the 'Ms Basic Connect Extensions' service.

#### Parameters

error | return location for error or `NULL`. |

#### Returns

a newly allocated MbimMessage, which should be freed with `mbim_message_unref()`.

Since: 1.26

### mbim_message_ms_basic_connect_extensions_device_caps_response_parse ()

    gboolean
    mbim_message_ms_basic_connect_extensions_device_caps_response_parse
                                   (const MbimMessage *message,
                                    MbimDeviceType *out_device_type,
                                    MbimCellularClass *out_cellular_class,
                                    MbimVoiceClass *out_voice_class,
                                    MbimSimClass *out_sms_class,
                                    MbimDataClass *out_data_class,
                                    MbimSmsCaps *out_sms_caps,
                                    MbimCtrlCaps *out_control_caps,
                                    guint32 *out_max_sessions,
                                    gchar **out_custom_data_class,
                                    gchar **out_device_id,
                                    gchar **out_firmware_info,
                                    gchar **out_hardware_info,
                                    guint32 *out_executor_index,
                                    GError **error);

Parses and returns parameters of the 'Device Caps' response command in the 'Ms Basic Connect Extensions' service.

#### Parameters

message | the MbimMessage. |
out_device_type | return location for a MbimDeviceType, or `NULL` if the 'DeviceType' field is not needed. | [out][optional][transfer none]
out_cellular_class | return location for a MbimCellularClass, or `NULL` if the 'CellularClass' field is not needed. | [out][optional][transfer none]
out_voice_class | return location for a MbimVoiceClass, or `NULL` if the 'VoiceClass' field is not needed. | [out][optional][transfer none]
out_sms_class | return location for a MbimSimClass, or `NULL` if the 'SmsClass' field is not needed. | [out][optional][transfer none]
out_data_class | return location for a MbimDataClass, or `NULL` if the 'DataClass' field is not needed. | [out][optional][transfer none]
out_sms_caps | return location for a MbimSmsCaps, or `NULL` if the 'SmsCaps' field is not needed. | [out][optional][transfer none]
out_control_caps | return location for a MbimCtrlCaps, or `NULL` if the 'ControlCaps' field is not needed. | [out][optional][transfer none]
out_max_sessions | return location for a guint32, or `NULL` if the 'MaxSessions' field is not needed. | [out][optional][transfer none]
out_custom_data_class | return location for a newly allocated string, or `NULL` if the 'CustomDataClass' field is not needed. Free the returned value with `g_free()`. | [out][optional][transfer full]
out_device_id | return location for a newly allocated string, or `NULL` if the 'DeviceId' field is not needed. Free the returned value with `g_free()`. | [out][optional][transfer full]
out_firmware_info | return location for a newly allocated string, or `NULL` if the 'FirmwareInfo' field is not needed. Free the returned value with `g_free()`. | [out][optional][transfer full]
out_hardware_info | return location for a newly allocated string, or `NULL` if the 'HardwareInfo' field is not needed. Free the returned value with `g_free()`. | [out][optional][transfer full]
out_executor_index | return location for a guint32, or `NULL` if the 'ExecutorIndex' field is not needed. | [out][optional][transfer none]
error | return location for error or `NULL`. |

#### Returns

`TRUE` if the message was correctly parsed, `FALSE` if `error` is set.

Since: 1.26

## Types and Values

### MbimPcoValue

    typedef struct {
        guint32 session_id;
        guint32 pco_data_size;
        guint32 pco_data_type;
        guint8 *pco_data_buffer;
    } MbimPcoValue;

A MbimPcoValue element.

#### Members

guint32 `session_id`; | a guint32. |
guint32 `pco_data_size`; | a guint32. |
guint32 `pco_data_type`; | a guint32. |
guint8 *`pco_data_buffer`; | an array of guint8 values. |

Since: 1.18

### MbimLteAttachConfiguration

    typedef struct {
        guint32 ip_type;
        guint32 roaming;
        guint32 source;
        gchar *access_string;
        gchar *user_name;
        gchar *password;
        guint32 compression;
        guint32 auth_protocol;
    } MbimLteAttachConfiguration;

A MbimLteAttachConfiguration element.

#### Members

guint32 `ip_type`; | a guint32. |
guint32 `roaming`; | a guint32. |
guint32 `source`; | a guint32. |
gchar *`access_string`; | a string. |
gchar *`user_name`; | a string. |
gchar *`password`; | a string. |
guint32 `compression`; | a guint32. |
guint32 `auth_protocol`; | a guint32. |

Since: 1.18

### MbimLteAttachConfigurationArray

    typedef MbimLteAttachConfiguration *MbimLteAttachConfigurationArray;

A NULL-terminated array of MbimLteAttachConfiguration elements.

Since: 1.24

### MbimSlot

    typedef struct {
        guint32 slot;
    } MbimSlot;

A MbimSlot element.

#### Members

guint32 `slot`; | a guint32. |

Since: 1.26

### MbimSlotArray

    typedef MbimSlot *MbimSlotArray;

A NULL-terminated array of MbimSlot elements.

Since: 1.26